<script setup lang="ts">
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

type Stock = {
  id: number
  name: string
  quantity: number | null
  qMin: number | null
  qMax: number | null
  dateUpdate: Date
}

const headers = [
  { title: 'Id', key: 'id' },
  {
    title: 'DateUpdate',
    key: 'dateUpdate',
    value: (item: any | Stock) => item.dateUpdate.toLocaleDateString()
  },
  { title: 'Name', key: 'name' },
  { title: 'Quantity', key: 'quantity' },
  { key: 'actions', sortable: false },
  { key: 'check-stock', sortable: false }
]

const dialog = ref(false)
const stocks = ref<Stock[]>([])
const refForm = ref<VForm | null>(null)
const form = ref(false)
const formCheck = ref(false)
const dialogDelete = ref(false)
const dialogAdd = ref(false)
const loading = ref(false)
const dialogCheckStock = ref(false)
const objStock = ref(0)
const getQty = ref('')
const selectedCheck = ref('')
const dialogPrint = ref(false)
const initialStock: Stock = {
  id: -1,
  name: '',
  quantity: null,
  qMin: null,
  qMax: null,
  dateUpdate: new Date()
}
const editedStock = ref<Stock>(JSON.parse(JSON.stringify(initialStock)))

const lowQty = computed(() =>
  stocks.value.filter(
    (item) => item.quantity !== null && item.qMin !== null && item.quantity <= item.qMin
  )
)

let editedIndex = -1
let lastId = 7

function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedStock.value = Object.assign({}, initialStock)
  })
}

function deleteItemConfirm() {
  //Delete item from list
  stocks.value.splice(editedIndex, 1)
  closeDelete()
}

function editItem(item: Stock) {
  editedIndex = stocks.value.indexOf(item)
  editedStock.value = Object.assign({}, item)
  dialog.value = true
}
function closeDialog() {
  dialog.value = false
  dialogCheckStock.value = false
  dialogAdd.value = false
  getQty.value = ''
  nextTick(() => {
    editedStock.value = Object.assign({}, initialStock)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    editedStock.value.dateUpdate = new Date(editedStock.value.dateUpdate)
    Object.assign(stocks.value[editedIndex], editedStock.value)
  } else {
    editedStock.value.id = lastId++
    editedStock.value.dateUpdate = new Date(editedStock.value.dateUpdate)
    stocks.value.push(editedStock.value)
  }

  closeDialog()
}

function deleteItem(item: Stock) {
  editedIndex = stocks.value.indexOf(item)
  editedStock.value = Object.assign({}, item)
  dialogDelete.value = true
}

function checkStockItem(item: Stock) {
  objStock.value = item.id
  selectedCheck.value = item.name
  dialogCheckStock.value = true
}

function addStockItem(item: Stock) {
  objStock.value = item.id
  selectedCheck.value = item.name
  dialogAdd.value = true
}

function checkStockSave() {
  // console.log(objStock)
  // console.log( stocks.value[objStock.value-1])
  stocks.value[objStock.value - 1].quantity = parseInt(getQty.value)
  stocks.value[objStock.value - 1].dateUpdate = new Date()

  closeDialog()
}
function addSave() {
  stocks.value[objStock.value - 1].quantity =
    stocks.value[objStock.value - 1].quantity! + parseInt(getQty.value)
  stocks.value[objStock.value - 1].dateUpdate = new Date()
  closeDialog()
}

function initialize() {
  stocks.value = [
    {
      id: 1,
      name: 'Cocoa Powder',
      quantity: 2,
      qMin: 3,
      qMax: 20,
      dateUpdate: new Date('2024-01-11')
    },
    {
      id: 2,
      name: 'Coffee Beans',
      quantity: 4,
      qMin: 5,
      qMax: 20,
      dateUpdate: new Date('2024-01-11')
    },
    { id: 3, name: 'Syrup', quantity: 5, qMin: 2, qMax: 20, dateUpdate: new Date('2024-01-11') },
    { id: 4, name: 'Milk', quantity: 3, qMin: 5, qMax: 20, dateUpdate: new Date('2024-01-11') },
    { id: 5, name: 'Creamer', quantity: 10, qMin: 4, qMax: 20, dateUpdate: new Date('2024-01-11') },
    {
      id: 6,
      name: 'Matcha Powder',
      quantity: 10,
      qMin: 3,
      qMax: 20,
      dateUpdate: new Date('2024-01-11')
    }
  ]
}

onMounted(() => {
  initialize()
})
</script>
<template>
  <div>
    <v-data-table style="background-color: #efe7e1" :headers="headers" :items="stocks">
      <template v-slot:top>
        <v-toolbar flat style="color: #f5f3ef; background-color: #8b7565">
          <v-toolbar-title>Stock Management</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-btn style="color: #c01b1b; background-color: #f9f8f5" prepend-icon="mdi-printer" class="rounded-pill mr-2"
            @click="dialogPrint = true">Print</v-btn>
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn style="color: #0043c7; background-color: #f9f8f5" prepend-icon="mdi-plus" class="rounded-pill"
                v-bind="props" color="primary">New Material</v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5"><br />Material</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="6" sm="6">
                        <v-text-field v-model="editedStock.name" :readonly="loading"
                          :rules="[(v) => !!v || 'Please input Material Name']" class="mb-2" clearable
                          label="Name"></v-text-field>
                      </v-col>
                      <v-col cols="6" sm="6">
                        <v-text-field v-model="editedStock.quantity" :readonly="loading"
                          :rules="[(v) => !!v || 'Please input Quantity']" clearable label="Quantity"
                          type="number"></v-text-field>
                      </v-col>

                      <v-col cols="6" sm="6">
                        <v-text-field v-model="editedStock.qMax" :readonly="loading"
                          :rules="[(v) => !!v || 'Please input Max Quantity']" clearable label="Max Quantity"
                          type="number"></v-text-field>
                      </v-col>
                      <v-col cols="6" sm="3">
                        <v-text-field v-model="editedStock.qMin" :readonly="loading"
                          :rules="[(v) => !!v || 'Please input Min Quantity']" clearable label="Min Quantity"
                          type="number"></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()">Save</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!--Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this Material?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="#81322c" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="#81322c" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:[`item.check-stock`]="{ item }">
        <v-btn @click="checkStockItem(item)" color="#349375" rounded="xl" class="mr-2">
          <v-icon size="small">mdi-check-circle</v-icon>
          Check Stock
        </v-btn>
        <v-btn @click="addStockItem(item)" rounded="xl">
          <v-icon size="small">mdi-plus-circle-outline</v-icon>
          Add
        </v-btn>

        <v-dialog v-if="dialogAdd" v-model="dialogAdd" persistent width="512" @keydown.enter.prevent="addSave()"
          @click:outside="closeDialog">
          <v-card>
            <v-card-title>
              <span class="text-h10">{{ selectedCheck }}</span>
            </v-card-title>
            <v-card-text>
              <v-form ref="refForm" v-model="formCheck" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field v-model="getQty" label="Quantity" name="Add Quantity" type="number"></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
            </v-card-text>
          </v-card>
        </v-dialog>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
  <v-dialog v-if="dialogCheckStock" v-model="dialogCheckStock" persistent width="512"
    @keydown.enter.prevent="checkStockSave()" @click:outside="closeDialog">
    <v-card>
      <v-card-title>
        <span class="text-h10">{{ selectedCheck }}</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="formCheck" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12" sm="6" md="4">
                <v-text-field v-model="getQty" label="Quantity" type="number"></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
    </v-card>
  </v-dialog>

  <v-dialog v-model="dialogPrint">
    <template> สินค้าใกล้หมดStock </template>
    <template>
      <v-data-table-virtual :headers="headers" height="400" item-value="name"></v-data-table-virtual>
    </template>
    <v-card class="mx-auto" width="800" prepend-icon="mdi-cart-outline">
      <template v-slot:title> สินค้าใกล้หมด Stock </template>
      <v-table>
        <thead>
          <tr>
            <th>Id</th>
            <th>Name</th>
            <th>Max Quantity</th>
            <th>Min Quantity</th>
            <th>Quantity</th>
            <th>Amount to Purchase</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="item in lowQty" :key="item.id">
            <td>{{ item.id }}</td>
            <td>{{ item.name }}</td>
            <td>{{ item.qMax }}</td>
            <td>{{ item.qMin }}</td>
            <td>{{ item.quantity }}</td>
            <td>{{ item.qMax! - item.quantity! }}</td>
          </tr>
        </tbody>
      </v-table>
    </v-card>
  </v-dialog>
</template>
